'use strict';

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                             It's module for run migration for every module which has dir "/migrations"
                                                                                                                                                                                                                                                                                                                                                                                                                                                                             in module root folder. Every files in dir must be
                                                                                                                                                                                                                                                                                                                                                                                                                                                                             [timestamp_miliseconds]__[name].js (example: 1538478025618__hitl_messages.js)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                           */

const getMigrationDirIfExist = (dirList, { root }) => {
  const migrationPath = _path2.default.resolve(root, './migrations');

  return (0, _fs.existsSync)(migrationPath) ? [...dirList, migrationPath] : dirList;
};

const runUp = (() => {
  var _ref = _asyncToGenerator(function* (knex, dir) {
    const dirFiles = (0, _fs.readdirSync)(dir).filter(function (file) {
      return (/^\d+__.+\.js$/.test(file)
      );
    }).sort();

    for (let index = 0; index < dirFiles.length; index++) {
      const migration = require(_path2.default.resolve(dir, dirFiles[index]));

      migration.up && (yield migration.up(knex));
    }
  });

  return function runUp(_x, _x2) {
    return _ref.apply(this, arguments);
  };
})();

module.exports = (() => {
  var _ref2 = _asyncToGenerator(function* (db, moduleDefinitions = []) {
    const migrationsDirList = moduleDefinitions.reduce(getMigrationDirIfExist, []);
    const knex = yield db.get();

    return {
      up: function () {
        return Promise.all(migrationsDirList.map(function (dir) {
          return runUp(knex, dir);
        }));
      },
      /*
        TODO: write it only with changes in "botpress CL"
        maybe it will be make this command: botpress migrate:[up||down] [module_name]
      */
      down: function () {
        return {};
      } // TODO: write it only with changes in "botpress CL"
    };
  });

  return function (_x3) {
    return _ref2.apply(this, arguments);
  };
})();
//# sourceMappingURL=migration.js.map